function [r]=onebootstrap(X,x0,High_Low,a0,a1,b0,b1,d0,d1)

stepa=1/2;
stepb=1/2;
stepd=0.1;
R=-99999999*ones(100,4);
dR=ones(1,3);
if High_Low==0
	prec=0.0004;
	prec_n=2;
	distance=1.5;
	safe_margin=1.5;
end
if High_Low==1
	prec=0.00001;
	prec_n=4;
	distance=5.5;
	safe_margin=2.5;
end
time=0;
n=125;
ind_upp_a=0;
ind_upp_b=0;
ind_upp_d=0;
shrinkstepsize=0;
while dR*dR'>prec||min(shrinkstepsize)==0||max([stepa,stepb,10*stepd])>=0.005
	R=likelihood_Est(X,stepa,stepb,stepd,a0,b0,d0,a1,b1,d1,x0,R);
	[rofR c]=size(R);
	R_new=-99999999*ones(9*rofR,c);
	R_new(1:rofR,:)=R;
	p=1;
	q=rofR+1;
	while p<=rofR
		a_val=R(p,2);
		b_val=R(p,3);
		d_val=R(p,4);
		r1=-1;
		while r1<=1
			r2=-1;
			while r2<=1
				r3=-1;
				while r3<=1
					a_val_new=max(a0,a_val+r1*stepa/3);
					b_val_new=max(b0,b_val+r2*stepb/3);
					d_val_new=max(d0,d_val+r3*stepd/3);
					R_new(q,2:4)=[a_val_new b_val_new d_val_new];
					R_new(q,1)=Loglik(a_val_new,b_val_new,d_val_new,x0,X);
					q=q+1;
					r3=r3+2;
				end
				r2=r2+2;
			end
			r1=r1+2;
		end
		p=p+1;
	end
	n=max(round(n-log(time+1)),prec_n); % Specify the reduced size of record.
	R=Resize_R(R_new,n); % Reduce the size of record.
	R_max=max(R);
	R_min=min(R);
	del_R=R_max-R_min;
	dR=del_R(1,2:4).*[1 1 10];
	time=time+1;
	shrinkstepsize=ones(1,7);
	if R_min(1,2)-a0<=safe_margin*stepa&&a0>1.01+0.1*stepa
		display(['a_0 = ',num2str(a0),' is too close to the lower bound.']);
		shrinkstepsize(1,1)=0;
		a0=max(1.01,R_min(1,2)-(distance+3)*stepa)+stepa*rand(1);
	else
		a0=max(1.01,R_min(1,2)-(distance+1)*stepa)+stepa*rand(1);
	end
	if a1-R_max(1,2)<=safe_margin*stepa
		ind_upp_a=ind_upp_a+1;
		display('a_1 is too close to the upper bound.');
		shrinkstepsize(1,2)=0;
		a1=max(a0,R_max(1,2)+(distance+2+2*ind_upp_a^0.5)*stepa);
	else
		a1=max(a0,R_max(1,2)+distance*stepa);
	end
	if R_min(1,3)-b0<=safe_margin*stepb&&b0>1.01+0.1*stepb
		display('b_0 is too close to the lower bound.');
		shrinkstepsize(1,3)=0;
		b0=max(1.01,R_min(1,3)-(distance+3)*stepb)+stepb*rand(1);
	else
		b0=max(1.01,R_min(1,3)-(distance+1)*stepb)+stepb*rand(1);
	end
	if b1-R_max(1,3)<=safe_margin*stepb
		ind_upp_b=ind_upp_b+1;
		display('b_1 is too close to the upper bound.');
		shrinkstepsize(1,4)=0;
		b1=max(b0,R_max(1,3)+(distance+2+16*ind_upp_b^0.5)*stepb);
	else
		b1=max(b0,R_max(1,3)+distance*stepb);
	end
	if R_min(1,4)-d0<=safe_margin*stepd&&d0>x0+0.1*stepd+0.01
		display('d_0 is too close to the lower bound.');
		shrinkstepsize(1,5)=0;
		d0=max(x0+0.01,R_min(1,4)-(distance+3)*stepd)+stepd*rand(1);
	else
		d0=max(x0+0.01,R_min(1,4)-(distance+1)*stepd)+stepd*rand(1);
	end
	if d1-R_max(1,4)<=safe_margin*stepd
		ind_upp_d=ind_upp_d+1;
		display('d_1 is too close to the upper bound.');
		shrinkstepsize(1,6)=0;
		d1=max(d0,R_max(1,4)+(distance+2+10*ind_upp_d^0.5)*stepd);
	else
		d1=max(d0,R_max(1,4)+distance*stepd);
	end
	if (a1-a0)*(b1-b0)*(d1-d0)/(stepa*stepb*stepd)>=8*80*12
		shrinkstepsize(1,7)=0;
		display('Current situation is not suitable for a significant stepsize-change.');
	end
	if shrinkstepsize(1,1:6)==ones(1,6)&High_Low==0&max([stepa stepb stepd])<=0.005
		display('Stepsizes are small enough. Stop searching.');
		break;
	end
	if time>15&&High_Low==1
		break;
	end
	if time>10&&High_Low==0
		break;
	end
	if shrinkstepsize(1,7)==1
		if shrinkstepsize(1,1)==1&&shrinkstepsize(1,2)==1
			stepa=max(stepa/3,0.001/log(time+1));
		else
			stepa=min(0.5*max(rand(1),0.1),max(0.01,stepa/(0.5+rand(1))));
		end
		if shrinkstepsize(1,3)==1&&shrinkstepsize(1,4)==1		
			stepb=max(stepb/3,0.001/log(time+1));
		else
			stepb=min(0.5*max(rand(1),0.1),max(0.01,stepb/(0.5+rand(1))));
		end
		if shrinkstepsize(1,5)==1&&shrinkstepsize(1,6)==1
			stepd=max(stepd/3,0.0001/log(time+1));
		else
			stepd=min(0.1*max(rand(1),0.1),max(0.001,stepd/(0.5+rand(1))));
		end
	else
		if shrinkstepsize(1,1)==1&&shrinkstepsize(1,2)==1
			stepa=max(stepa/1.5,0.001/log(time+1));
		else
			stepa=min(0.5*max(rand(1),0.1),max(0.01,stepa/(0.5+rand(1))));
		end
		if shrinkstepsize(1,3)==1&&shrinkstepsize(1,4)==1		
			stepb=max(stepb/1.5,0.001/log(time+1));
		else
			stepb=min(0.5*max(rand(1),0.1),max(0.01,stepb/(0.5+rand(1))));
		end
		if shrinkstepsize(1,5)==1&&shrinkstepsize(1,6)==1
			stepd=max(stepd/1.5,0.0001/log(time+1));
		else
			stepd=min(0.01*max(rand(1),0.1),max(0.001,stepd/(0.5+rand(1))));
		end
	end
	display(['Stepsize of alpha is set to be ',num2str(stepa)]);
	display(['Stepsize of beta is set to be ',num2str(stepb)]);
	display(['Stepsize of delta is set to be ',num2str(stepd)]);
	if min(shrinkstepsize)==0
		n=n+round(log(time+1));
	end
end
S=size(R);
N=S(1,1);
m=max(R(:,1));
t=1;
c=0;
while t<=N&&c==0
	if m==R(t,1)
		r=R(t,:);
		c=1;
	end
	t=t+1;
end